import java.io.*;
import java.net.*;
import java.util.*;

public class Httpd {
    public static void main(String[] args) {
        try {
            ServerSocket serverSocket = new ServerSocket(8080);
            while (true) {
                Socket socket = serverSocket.accept();
                new Service(socket).start();
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}

class Service extends Thread {
    private Socket socket;

    public Service(Socket socket) {
        this.socket = socket;
    }

    public void run() {
        BufferedReader in = null;
        BufferedWriter out = null;
        try {
            in = new BufferedReader(new InputStreamReader(socket.getInputStream()));
            out = new BufferedWriter(new OutputStreamWriter(socket.getOutputStream()));
            out.write("HTTP/1.0 200 OK\r\n");
            out.write("Cotent-Type: text/html\r\n");
            out.write("\r\n");
            String s;
            StringTokenizer st = new StringTokenizer(s = in.readLine());
            st.nextToken();
            File file = new File(URLDecoder.decode(st.nextToken().replace('/', File.separatorChar)));
            System.out.println("request from " + socket.getInetAddress().getHostName());
            System.out.println("-----");
            System.out.println(s);
            while (!"".equals(s = in.readLine()))
                System.out.println(s);
            System.out.println("-----");
            if (!InetAddress.getByName("localhost").equals(socket.getInetAddress())) {
                out.write(file + ": not available\r\n");
            } else {
                if (file.isDirectory()) {
                    File[] files = file.listFiles();
                    for (int i = 0; i < files.length; i++) {
                        String name = files[i].toString().replace(File.separatorChar, '/');
                        if (files[i].isDirectory())
                            name += "/";
                        out.write("<a href=\"" + name + "\">" + name + "</a>\r\n");
                        out.write("<br>\r\n");
                    }
                    out.write(file + ": " + files.length + " files\r\n");
                } else {
                    out.write(file + ": not available\r\n");
                }
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
        try {
            out.close();
            in.close();
            socket.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}